%% hairplots_plotting.m is a function that that can be used to plot hairplots
%% generated by hairplots.m
function [saved] = hairplots_plotting(mspec, ti, LF, spath, gpath,bol_detrend_w,varargin)

if nargin == 7
    if isstr(varargin{1})
        fcastType = ['_',varargin{1}];
        startDt = 1;
    else
        startDt = varargin{1};
        fcastType = '';
    end
    hairColor = 'r';
    
elseif nargin == 8
    fcastType = ['_',varargin{1}];
    hairColor = 'r';
    startDt = varargin{2};
else
    fcastType = '';
    hairColor = 'r';
    startDt = 1;
end

if bol_detrend_w
    detrend_w = '_detrendw';
else
    detrend_w = '';
end

load([spath,'hairplots_mc',fcastType,'_',num2str(mspec),'_',num2str(ti(end)*100),'.mat']); % data and forecasts
ti = [ti;ti(end)+[0.25:0.25:LF*0.25]'];
hair = hair(:,1:length(ti));

fprintf('Plotting smoothed states and hairplots from %f.2 to %f.2\n',ti(startDt),ti(end));

f = figure();                                       % figure
p=plot(ti(startDt:end),hair(1,startDt:end),'k','LineWidth',1.5);    % plot smoothed states
xlim([ti(startDt) ti(end)]);                        % set x-axis limits
hold on;                                            % hold plot on
for i = 2:size(hair,1)                              % plot hairplot forecasts
        p=plot(ti(startDt:i+LF-1),hair(i,startDt:i+LF-1),hairColor);
end

set(gca,'XTick',ti(find(ti==1965):40:length(ti)));
set(gca,'FontSize',18);
saveas(f,[gpath,'hairplots_mc',fcastType,num2str(mspec),detrend_w,'.pdf'])    % save figure as pdf
saved = 1;