%% hairplots_plotting.m is a function that that can be used to plot hairplots
%% generated by hairplots.m
function [saved] = hairplots_plotting_detrend(mspec, varargin)

if nargin == 2
    fcastType = ['_',varargin{1}];
    if strcmp( fcastType, '_ar2')
        fcastName = ' - AR(2)';
    elseif strcmp( fcastType, '_rw' )
        fcastName = ' - rand. walk w/ drift';
    elseif strcmp( fcastType, '_ar2fullSample' )
        fcastName = ' - AR(2) full sample est.';
    end
    hairColor = 'r';
else
    fcastType = '';
    fcastName = '';
    hairColor = 'r';
end

% USER SETTINGS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load(['hairplots_mc',fcastType,num2str(mspec),'_long.mat']); % data and forecasts
ti = 1964.75:.25:2017.50; % dates
startDt = 1;            % select xlim (lower)
hair = hair(:,1:length(ti));
LF = 19;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('Plotting smoothed states and hairplots from %f.2 to %f.2\n',ti(startDt),ti(end));

f = figure();                                       % figure
p=plot(ti(startDt:end),hair(1,startDt:end),'k');    % plot smoothed states
xlim([ti(startDt) ti(end)]);                        % set x-axis limits
hold on;                                            % hold plot on
for i = 2:size(hair,1)                              % plot hairplot forecasts
    p=plot(ti(startDt:i+LF),hair(i,startDt:i+LF),hairColor);
end

set(gca,'FontSize',18);
fcastType = '';
saveas(f,['hairplots_mc',fcastType,num2str(mspec),'_detrend_wage.pdf'])    % save figure as pdf
saved = 1;