function counter_new = getcounter_fullHist(ShockremoveList,peachflag,psize,Enddate_forecastfile,...
                                  sm_states,sm_shocks,sm_states_peach,sm_shocks_peach,...
                                  Startdate,nobs,nshocks,qahead,nvar,TTT,RRR,DD,ZZ)

counter_new = zeros(nvar*(Enddate_forecastfile-1),peachflag+1,length(ShockremoveList));

for peachcount = 0:peachflag

    Enddate1 = Enddate_forecastfile;

    switch peachcount
        case 0 % Unconditional
            z0 = sm_states(:,1);
            shocks_all = sm_shocks(:,2:nobs)';
        case 1 % Full conditional (conditional on T+1 data for almost all variables)
            z0 = sm_states_peach(:,Startdate);
            shocks_all = sm_shocks_peach(:,2:nobs+psize)';
    end
    
    shockcount = 0;
    
    for Shockremove = ShockremoveList
        shockcount = shockcount + 1;
        
        z = z0;
        
        shocks = shocks_all;

        if any(Shockremove == [1:nshocks]),
            shocks(:,Shockremove) = 0;
        elseif Shockremove == 0
            shocks(:,:) = 0;
        end
        
        % shocks(Enddate1-Startdate-qahead_extra+1:Enddate1-Startdate,:) = 0;
        
        switch peachcount
            case 0
                shocks(Enddate1-1-qahead+1:Enddate1-1,:) = 0; % JC 7/9/2012
            case 1
                shocks(Enddate1-1-(qahead-psize)+1:Enddate1-1,:) = 0; % JC 7/9/2012
        end
        
        yycounter = zeros(Enddate1-1,nvar);
        for t = 1:Enddate1-1
            z = TTT*z+RRR*shocks(t,:)';
            yycounter(t,:) = (DD+ZZ*z)';
        end
        
        counter_new(:,peachcount+1,shockcount) = yycounter(:)';
        
    end
end